<?php
/**
*
* @package acp
* @version $Id: acp_post_expire.php 8990 2009-04-13 20:48:19Z crazygandalf $
* @copyright (c) 2009 crazygandalf
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_post_expire
{
	var $u_action;

	function main($id, $mode)
	{
		global $db, $user, $auth, $template;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;

		$user->add_lang('mods/pe');

		$action	= request_var('action', '');
		$submit = (isset($_POST['submit'])) ? true : false;

		if ($mode != 'settings')
		{
			return;
		}

		$this->tpl_name = 'acp_post_expire';
		$this->page_title = 'ACP_POST_EXPIRE_SETTINGS';

		$expire_enable			= request_var('expire_enable', (int) $config['expire_enable']);
		$expire_default_action			= request_var('expire_default_action', (int) $config['expire_default_action']);
		$expire_kind_set			= request_var('expire_kind_set', (int) $config['expire_kind_set']);
		$expire_default_forum			= request_var('expire_default_forum', (int) $config['expire_default_forum']);
		$expire_colour_set			= request_var('expire_colour_set', (int) $config['expire_colour_set']);
		$expire_colour_time			= request_var('expire_colour_time', (int) abs($config['expire_colour_time']));
		$expire_max_time			= request_var('expire_max_time', (int) abs($config['expire_max_time']));

		$form_name = 'acp_post_expire';
		add_form_key($form_name);

		if (!function_exists('make_forum_select'))
		{
			include($phpbb_root_path . 'includes/functions_admin.' . $phpEx);
		}
		$s_expire_forum_options = make_forum_select($expire_default_forum, false, true, true);

		if ($submit)
		{
			if (!check_form_key($form_name))
			{
				trigger_error($user->lang['FORM_INVALID']. adm_back_link($this->u_action), E_USER_WARNING);
			}

			$error = array();

			$message = $user->lang['POST_EXPIRE_SETTINGS_CHANGED'];
			$log = 'POST_EXPIRE_SETTINGS_CHANGED';

			set_config('expire_enable', $expire_enable);
			set_config('expire_default_action', $expire_default_action);
			set_config('expire_kind_set', $expire_kind_set);
			set_config('expire_default_forum', $expire_default_forum);
			set_config('expire_colour_set', $expire_colour_set);
			set_config('expire_colour_time', $expire_colour_time);
			set_config('expire_max_time', $expire_max_time);

			add_log('admin', 'LOG_' . $log);
			trigger_error($message . adm_back_link($this->u_action));
		}

		$checked = 'checked="checked"';
		
		$template->assign_vars(array(
			'U_ACTION'				=> $this->u_action,
			'EXPIRE_ENABLE' => $expire_enable,
			'EXPIRE_KIND_SET_0' => ($expire_kind_set == 0) ? $checked : '', 
			'EXPIRE_KIND_SET_1' => ($expire_kind_set == 1) ? $checked : '',
			'EXPIRE_KIND_SET_2' => ($expire_kind_set == 2) ? $checked : '',
			'EXPIRE_DEFAULT_ACTION_0' => ($expire_default_action == 0) ? $checked : '',
			'EXPIRE_DEFAULT_ACTION_1' => ($expire_default_action == 1) ? $checked : '',
			'EXPIRE_DEFAULT_ACTION_2' => ($expire_default_action == 2) ? $checked : '',
			'EXPIRE_DEFAULT_ACTION_3' => ($expire_default_action == 3) ? $checked : '',
			'S_EXPIRE_FORUM_OPTIONS' => $s_expire_forum_options,
			'EXPIRE_COLOUR_SET' => $expire_colour_set,
			'EXPIRE_COLOUR_TIME' => $expire_colour_time,
			'EXPIRE_MAX_TIME' => $expire_max_time,
		));
	}
}

?>
