<?php
/**
*
* @package phpBB3
* @version $Id: index.php 9003 2009-10-05 22:52:00Z crazygandalf $
* @copyright (c) 2009 carazygandalf
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
define('IN_INSTALL', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/acp/auth.' . $phpEx);
include($phpbb_root_path . 'includes/acp/acp_modules.' . $phpEx);
include($phpbb_root_path . 'includes/db/db_tools.' . $phpEx);

global $db, $user;

$user->session_begin();
$auth->acl($user->data);
$user->setup(array('mods/pe', 'acp/common', 'install'));
$user->theme['template_storedb'] = false;

if (!$auth->acl_get('a_'))
{
	trigger_error('NO_ADMIN');
}

$msg = '';

$db_tools = new phpbb_db_tools($db);

//Permissions
$auth_admin = new auth_admin();
$auth_admin->acl_add_option(array(
	'local'      => array(),
  'global'   => array('a_post_expire', 'u_post_expire_delete', 'u_post_expire_lock', 'u_post_expire_move', 'u_post_expire_lockandmove', 'u_post_expire_only', 'u_topic_expire_only', 'u_expire_default_forum')
));
    
$msg .=  '<span>' . $user->lang['INSTALL_PERM_ADDED'] . '</span><br />';

//Tables changes
//post_expire_time
if ($db_tools->sql_column_exists(POSTS_TABLE, 'post_expire_time'))
{
	$msg .=  '<span>' . sprintf($user->lang['INSTALL_TABLE_ALREADY_ALTERED'], POSTS_TABLE) . '</span><br />';
} 
else
{
	$db_tools->sql_column_add(POSTS_TABLE, 'post_expire_time', array('UINT:11', 0));
	$msg .=  '<span>' . sprintf($user->lang['INSTALL_TABLE_ALTERED'], POSTS_TABLE) . '</span><br />';
}

//topic_expire_time
if ($db_tools->sql_column_exists(TOPICS_TABLE, 'topic_expire_time'))
{
	$msg .=  '<span>' . sprintf($user->lang['INSTALL_TABLE_ALREADY_ALTERED'], TOPICS_TABLE) . '</span><br />';
} 
else
{
	$db_tools->sql_column_add(TOPICS_TABLE, 'topic_expire_time', array('UINT:11', 0));
	$msg .=  '<span>' . sprintf($user->lang['INSTALL_TABLE_ALTERED'], TOPICS_TABLE) . '</span><br />';
}

//topic_expire_type
if ($db_tools->sql_column_exists(TOPICS_TABLE, 'topic_expire_type'))
{
	$msg .=  '<span>' . sprintf($user->lang['INSTALL_TABLE_ALREADY_ALTERED'], TOPICS_TABLE) . '</span><br />';
} 
else
{
	$db_tools->sql_column_add(TOPICS_TABLE, 'topic_expire_type', array('BOOL', 0));
	$msg .=  '<span>' . sprintf($user->lang['INSTALL_TABLE_ALTERED'], TOPICS_TABLE) . '</span><br />';
}

//expire_forum_id
if ($db_tools->sql_column_exists(TOPICS_TABLE, 'expire_forum_id'))
{
	$msg .=  '<span>' . sprintf($user->lang['INSTALL_TABLE_ALREADY_ALTERED'], TOPICS_TABLE) . '</span><br />';
} 
else
{
	$db_tools->sql_column_add(TOPICS_TABLE, 'expire_forum_id', array('UINT', 0));
	$msg .=  '<span>' . sprintf($user->lang['INSTALL_TABLE_ALTERED'], TOPICS_TABLE) . '</span><br />';
}

//Config
set_config('expire_enable', 1);
set_config('expire_kind_set', 2);
set_config('expire_default_action', 0);
set_config('expire_default_forum', 0);
set_config('expire_colour_set', 1);
set_config('expire_colour_time', 0);
set_config('expire_max_time', 0);

$msg .=  '<br /><span>' . $user->lang['INSTALL_CONFIGURATION'] . '</span><br />';

//Module
$_module = new acp_modules();

$sql = 'SELECT module_id
	FROM ' . MODULES_TABLE . "
	WHERE module_langname = 'ACP_POST_EXPIRE_SETTINGS'";
$result = $db->sql_query($sql);
$row = $db->sql_fetchrow($result);
$db->sql_freeresult($result);
		
if (!$row) 
{
	// Lets get the .MOD module ID so we can insert our module there
	$sql = 'SELECT module_id
		FROM ' . MODULES_TABLE . "
		WHERE module_langname = '" . $db->sql_escape('ACP_MESSAGES') . "'";
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
		
	$post_expire_settings = array(
		'module_basename'	=> 'post_expire',
		'module_enabled'	=> 1,
		'module_display'	=> 1,
		'parent_id'			=> (int) $row['module_id'],
		'module_class'		=> 'acp',
		'module_langname'	=> 'ACP_POST_EXPIRE_SETTINGS',
		'module_mode'		=> 'settings',
		'module_auth'		=> 'acl_a_post_expire',
	);
	$_module->update_module_data($post_expire_settings);	

	$msg .=  '<span>' . $user->lang['INSTALL_PE_MODULE'] . '</span><br />';
}

global $cache;
$cache->purge();
add_log('admin', 'LOG_PURGE_CACHE');

$msg .=  '<span>' . $user->lang['LOG_PURGE_CACHE'] . '</span><br />';
$msg .=  '<br /><span>' . $user->lang['INSTALL_END_NOTES'] . '</span><br />';
$msg .= sprintf($user->lang['INSTALL_RETURN'], '<a href="' . append_sid("{$phpbb_root_path}index.$phpEx") . '">', '</a>');

// Assign index specific vars
$template->assign_vars(array(
	'TITLE'	=> $user->lang['INSTALL_POST_EXPIRE'],
	'BODY'	=> $msg,
));

// Output page
page_header($user->lang['INSTALL_PANEL']);

// Set custom template for admin area
$template->set_custom_template($phpbb_root_path . 'adm/style', 'admin');
$template->assign_var('T_TEMPLATE_PATH', $phpbb_root_path . 'adm/style');

$template->set_filenames(array(
	'body' => 'install_main.html')
);

page_footer();

?>
